# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CustomerInsights::Mgmt::V2017_01_01
  module Models
    #
    # The relationship link resource format.
    #
    class RelationshipLinkResourceFormat < ProxyResource

      include MsRestAzure

      # @return [Hash{String => String}] Localized display name for the
      # Relationship Link.
      attr_accessor :display_name

      # @return [Hash{String => String}] Localized descriptions for the
      # Relationship Link.
      attr_accessor :description

      # @return [String] The InteractionType associated with the Relationship
      # Link.
      attr_accessor :interaction_type

      # @return [String] The name of the Relationship Link.
      attr_accessor :link_name

      # @return [Array<RelationshipLinkFieldMapping>] The mappings between
      # Interaction and Relationship fields.
      attr_accessor :mappings

      # @return [Array<ParticipantPropertyReference>] The property references
      # for the Profile of the Relationship.
      attr_accessor :profile_property_references

      # @return [ProvisioningStates] Provisioning state. Possible values
      # include: 'Provisioning', 'Succeeded', 'Expiring', 'Deleting',
      # 'HumanIntervention', 'Failed'
      attr_accessor :provisioning_state

      # @return [Array<ParticipantPropertyReference>] The property references
      # for the Related Profile of the Relationship.
      attr_accessor :related_profile_property_references

      # @return [String] The Relationship associated with the Link.
      attr_accessor :relationship_name

      # @return [String] The relationship guid id.
      attr_accessor :relationship_guid_id

      # @return [String] The hub name.
      attr_accessor :tenant_id


      #
      # Mapper for RelationshipLinkResourceFormat class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RelationshipLinkResourceFormat',
          type: {
            name: 'Composite',
            class_name: 'RelationshipLinkResourceFormat',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.description',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              interaction_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.interactionType',
                type: {
                  name: 'String'
                }
              },
              link_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.linkName',
                type: {
                  name: 'String'
                }
              },
              mappings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.mappings',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'RelationshipLinkFieldMappingElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'RelationshipLinkFieldMapping'
                      }
                  }
                }
              },
              profile_property_references: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.profilePropertyReferences',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ParticipantPropertyReferenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ParticipantPropertyReference'
                      }
                  }
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              related_profile_property_references: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.relatedProfilePropertyReferences',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ParticipantPropertyReferenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ParticipantPropertyReference'
                      }
                  }
                }
              },
              relationship_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.relationshipName',
                type: {
                  name: 'String'
                }
              },
              relationship_guid_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.relationshipGuidId',
                type: {
                  name: 'String'
                }
              },
              tenant_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.tenantId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
